# sf_command

            int    sf_command (SNDFILE *sndfile, int cmd, void *data, int datasize) ;

This function allows the caller to retrieve information from or change aspects of the library behaviour. Examples include retrieving a string containing the library version or changing the scaling applied to floating point sample data during read and write. Most of these operations are performed on a per-file basis.

The cmd parameter is a integer identifier which is defined in <sndfile.h>. All of the valid command identifiers have names begining with "SFC_". Data is passed to and returned from the library by use of a void pointer. The library will not read or write more than datasize bytes from the void pointer. For some calls no data is required in which case data should be NULL and datasize may be used for some other purpose.

The available commands are as follows:

SFC_GET_LIB_VERSION | Retrieve the version of the library.
SFC_GET_LOG_INFO | Retrieve the internal per-file operation log.
SFC_CALC_SIGNAL_MAX | Retrieve the measured maximum signal value.
SFC_CALC_NORM_SIGNAL_MAX | Retrieve the measured normalised maximum signal value.
SFC_CALC_MAX_ALL_CHANNELS | Calculate peaks for all channels.
SFC_CALC_NORM_MAX_ALL_CHANNELS | Calculate normalised peaks for all channels.
SFC_SET_NORM_FLOAT | Modify the normalisation behaviour of the floating point reading and writing functions.
SFC_SET_NORM_DOUBLE | Modify the normalisation behaviour of the double precision floating point reading and writing functions.
SFC_GET_NORM_FLOAT | Retrieve the current normalisation behaviour of the floating point reading and writing functions.
SFC_GET_NORM_DOUBLE | Retrieve the current normalisation behaviour of the double precision floating point reading and writing functions.
SFC_GET_SIMPLE_FORMAT_COUNT | Retrieve the number of simple formats supported by libsndfile.
SFC_GET_SIMPLE_FORMAT | Retrieve information about a simple format.
SFC_GET_FORMAT_INFO | Retrieve information about a major or subtype format.
SFC_GET_FORMAT_MAJOR_COUNT | Retrieve the number of major formats.
SFC_GET_FORMAT_MAJOR | Retrieve information about a major format type.
SFC_GET_FORMAT_SUBTYPE_COUNT | Retrieve the number of subformats.
SFC_GET_FORMAT_SUBTYPE | Retrieve information about a subformat.
SFC_SET_ADD_PEAK_CHUNK | Switch the code for adding the PEAK chunk to WAV and AIFF files on or off.
SFC_UPDATE_HEADER_NOW | Used when a file is open for write, this command will update the file header to reflect the data written so far.
SFC_SET_UPDATE_HEADER_AUTO | Used when a file is open for write, this command will cause the file header to be updated after each write to the file.
SFC_FILE_TRUNCATE | Truncate a file open for write or for read/write.
SFC_SET_RAW_START_OFFSET | Change the data start offset for files opened up as SF_FORMAT_RAW.

##
SFC_GET_LIB_VERSION

Retrieve the version of the library as a string.

Parameters:

            sndfile  : Not used
            cmd      : SFC_GET_LIB_VERSION
            data     : A pointer to a char buffer
            datasize : The size of the buffer

Example:

            char  buffer [128] ;
            sf_command (NULL, SFC_GET_LIB_VERSION, buffer, sizeof (buffer)) ;

Return value:
  This call will return the length of the retrieved version string.

Notes:
  The string returned in the buffer passed to this function will not overflow the buffer and will always be null terminated .

##
SFC_GET_LOG_INFO

Retrieve the log buffer generated when opening a file as a string. This log buffer can often contain a good reason for why libsndfile failed to open a particular file.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_LOG_INFO
            data     : A pointer to a char buffer
            datasize : The size of the buffer

Example:

            char  buffer [2048] ;
            sf_command (sndfile, SFC_GET_LOG_INFO, buffer, sizeof (buffer)) ;

Return value:
  This call will return the length of the retrieved version string.

Notes:
  The string returned in the buffer passed to this function will not overflow the buffer and will always be null terminated .

##
SFC_CALC_SIGNAL_MAX

Retrieve the measured maximum signal value. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_SIGNAL_MAX
            data     : A pointer to a double
            datasize : sizeof (double)

Example:

            double   max_val ;
            sf_command (sndfile, SFC_CALC_SIGNAL_MAX, &max_val, sizeof (max_val)) ;

Return value:
  Zero on success, non-zero otherwise.

##
SFC_CALC_NORM_SIGNAL_MAX

Retrieve the measured normailised maximum signal value. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_NORM_SIGNAL_MAX
            data     : A pointer to a double
            datasize : sizeof (double)

Example:

            double   max_val ;
            sf_command (sndfile, SFC_CALC_NORM_SIGNAL_MAX, &max_val, sizeof (max_val)) ;

Return value:
  Zero on success, non-zero otherwise.

##
SFC_CALC_MAX_ALL_CHANNELS

Calculate peaks for all channels. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_MAX_ALL_CHANNELS
            data     : A pointer to a double
            datasize : sizeof (double) * number_of_channels

Example:

            double   peaks [number_of_channels] ;
            sf_command (sndfile, SFC_CALC_MAX_ALL_CHANNELS, peaks, sizeof (peaks)) ;

Return value:
  Zero if peaks have been calculated successfully and non-zero otherwise.

##
SFC_CALC_NORM_MAX_ALL_CHANNELS

Calculate normalised peaks for all channels. This involves reading through the whole file which can be slow on large files.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_CALC_NORM_MAX_ALL_CHANNELS
            data     : A pointer to a double
            datasize : sizeof (double) * number_of_channels

Example:

            double   peaks [number_of_channels] ;
            sf_command (sndfile, SFC_CALC_NORM_MAX_ALL_CHANNELS, peaks, sizeof (peaks)) ;

Return value:
  Zero if peaks have been calculated successfully and non-zero otherwise.

##
SFC_SET_NORM_FLOAT

This command only affects data read from or written to using the floating point functions:

    	size_t    sf_read_float    (SNDFILE *sndfile, float *ptr, size_t items) ;
    	size_t    sf_readf_float   (SNDFILE *sndfile, float *ptr, size_t frames) ;

    	size_t    sf_write_float   (SNDFILE *sndfile, float *ptr, size_t items) ;
    	size_t    sf_writef_float  (SNDFILE *sndfile, float *ptr, size_t frames) ;

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_NORM_FLOAT
            data     : NULL
            datasize : SF_TRUE or SF_FALSE

For read operations setting normalisation to SF_TRUE means that the data from all subsequent reads will be be normalised to the range [-1.0, 1.0].

For write operations, setting normalisation to SF_TRUE means than all data supplied to the float write functions should be in the range [-1.0, 1.0] and will be scaled for the file format as necessary.

For both cases, setting normalisation to SF_FALSE means that no scaling will take place.

Example:

            sf_command (sndfile, SFC_SET_NORM_FLOAT, NULL, SF_TRUE) ;

            sf_command (sndfile, SFC_SET_NORM_FLOAT, NULL, SF_FALSE) ;

Return value:
  Returns 1 on success or 0 for failure.

##
SFC_SET_NORM_DOUBLE

This command only affects data read from or written to using the double precision floating point functions:

    	size_t    sf_read_double    (SNDFILE *sndfile, double *ptr, size_t items) ;
    	size_t    sf_readf_double   (SNDFILE *sndfile, double *ptr, size_t frames) ;

    	size_t    sf_write_double   (SNDFILE *sndfile, double *ptr, size_t items) ;
    	size_t    sf_writef_double  (SNDFILE *sndfile, double *ptr, size_t frames) ;

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_NORM_DOUBLE
            data     : NULL
            datasize : SF_TRUE or SF_FALSE

For read operations setting normalisation to SF_TRUE means that the data from all subsequent reads will be be normalised to the range [-1.0, 1.0].

For write operations, setting normalisation to SF_TRUE means than all data supplied to the double write functions should be in the range [-1.0, 1.0] and will be scaled for the file format as necessary.

For both cases, setting normalisation to SF_FALSE means that no scaling will take place.

Example:

            sf_command (sndfile, SFC_SET_NORM_DOUBLE, NULL, SF_TRUE) ;

            sf_command (sndfile, SFC_SET_NORM_DOUBLE, NULL, SF_FALSE) ;

Return value:
  Returns 1 on success or 0 for failure.

##
SFC_GET_NORM_FLOAT

Retrieve the current float normalisation mode.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_NORM_FLOAT
            data     : NULL
            datasize : anything

Example:

            normalisation = sf_command (sndfile, SFC_GET_NORM_FLOAT, NULL, 0) ;

Return value:
  Returns TRUE if normaisation is on and FALSE otherwise.

##
SFC_GET_NORM_DOUBLE

Retrieve the current float normalisation mode.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_GET_NORM_DOUBLE
            data     : NULL
            datasize : anything

Example:

            normalisation = sf_command (sndfile, SFC_GET_NORM_DOUBLE, NULL, 0) ;

Return value:
  Returns TRUE if normalisation is on and FALSE otherwise.

##
SFC_GET_SIMPLE_FORMAT_COUNT

Retrieve the number of simple formats supported by libsndfile.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_SIMPLE_FORMAT_COUNT
            data     : a pointer to an int
            datasize : sizeof (int)

Example:

            int  count ;
            sf_command (sndfile, SFC_GET_SIMPLE_FORMAT_COUNT, &count, sizeof (int)) ;

Return value:
  0

##
SFC_GET_SIMPLE_FORMAT

Retrieve information about a simple format.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_SIMPLE_FORMAT
            data     : a pointer to an  SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

The SF_FORMAT_INFO struct is defined in <sndfile.h> as:

            typedef struct
            {   int         format ;
                const char  *name ;
                const char  *extension ;
            } SF_FORMAT_INFO ;

When sf_command() is called with SF_GET_SIMPLE_FORMAT, the value of the format field should be the format number (ie 0 <= format <= count value obtained using SF_GET_SIMPLE_FORMAT_COUNT).

Example:

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_SIMPLE_FORMAT_COUNT, &count, sizeof (int)) ;

            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_SIMPLE_FORMAT, &format_info, sizeof (format_info)) ;
                printf ("%08x  %s %s\n", format_info.format, format_info.name, format_info.extension) ;
                } ;

Return value:
  0 on success and non-zero otherwise.
  The value of the format field of the SF_FORMAT_INFO struct will be an value which can be placed in the format field of an SF_INFO struct when a file is to be opened for write.
  The name field will contain a char* pointer to the name of the string ie "WAV (Microsoft 16 bit PCM)".
  The extention field will contain the most commonly used file extension for that file type.

##
SFC_GET_FORMAT_INFO

Retrieve information about a major or subtype format.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_INFO
            data     : a pointer to an SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

The SF_FORMAT_INFO struct is defined in <sndfile.h> as:

            typedef struct
            {   int         format ;
                const char  *name ;
                const char  *extension ;
            } SF_FORMAT_INFO ;

When sf_command() is called with SF_GET_FORMAT_INFO, the format field is examined and if (format & SF_FORMAT_TYPEMASK) is a valid format then the struct is filled in with information about the given major type. If (format & SF_FORMAT_TYPEMASK) is FALSE and (format & SF_FORMAT_SUBMASK) is a valid subtype format then the struct is filled in with information about the given subtype.

Example:

            SF_FORMAT_INFO	format_info ;

            format_info.format = SF_FORMAT_WAV ;
            sf_command (sndfile, SFC_GET_FORMAT_INFO, &format_info, sizeof (format_info)) ;
            printf ("%08x  %s %s\n", format_info.format, format_info.name, format_info.extension) ;

            format_info.format = SF_FORMAT_ULAW ;
            sf_command (sndfile, SFC_GET_FORMAT_INFO, &format_info, sizeof (format_info)) ;
            printf ("%08x  %s\n", format_info.format, format_info.name) ;

Return value:
  0 on success and non-zero otherwise.

##
SFC_GET_FORMAT_MAJOR_COUNT

Retrieve the number of major formats.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_MAJOR_COUNT
            data     : a pointer to an int
            datasize : sizeof (int)

Example:

            int  count ;
            sf_command (sndfile, SFC_GET_FORMAT_MAJOR_COUNT, &count, sizeof (int)) ;

Return value:
  0

##
SFC_GET_FORMAT_MAJOR

Retrieve information about a major format type.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_MAJOR
            data     : a pointer to an  SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

Example:

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_FORMAT_MAJOR_COUNT, &count, sizeof (int)) ;

            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_FORMAT_MAJOR, &format_info, sizeof (format_info)) ;
                printf ("%08x  %s %s\n", format_info.format, format_info.name, format_info.extension) ;
                } ;

For a more comprehensive example, see the program list_formats.c in the examples/ directory of the libsndfile source code distribution.

Return value:
  0 on success and non-zero otherwise.
  The value of the format field will one of the major format identifiers suc as SF_FORMAT_WAV SF_FORMAT_AIFF.
  The name field will contain a char* pointer to the name of the string ie "WAV (Microsoft)".
  The extention field will contain the most commonly used file extension for that file type.

##
SFC_GET_FORMAT_SUBTYPE_COUNT

Retrieve the number of subformats.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_SUBTYPE_COUNT
            data     : a pointer to an int
            datasize : sizeof (int)

Example:

            int   count ;
            sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE_COUNT, &count, sizeof (int)) ;

Return value:
  0

##
SFC_GET_FORMAT_SUBTYPE

Retrieve information about a subformat.

Parameters:

            sndfile  : Not used.
            cmd      : SFC_GET_FORMAT_SUBTYPE
            data     : a pointer to an SF_FORMAT_INFO struct
            datasize : sizeof (SF_FORMAT_INFO)

Example:

            SF_FORMAT_INFO	format_info ;
            int             k, count ;

            sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE_COUNT, &count, sizeof (int)) ;

            /* Retrieve all the subtypes supported by the WAV format. */
            for (k = 0 ; k < count ; k++)
            {   format_info.format = k ;
                sf_command (sndfile, SFC_GET_FORMAT_SUBTYPE, &format_info, sizeof (format_info)) ;
                if (! sf_format_check (format.info | SF_FORMAT_WAV))
                   continue ;
                printf ("%08x  %s\n", format_info.format, format_info.name) ;
                } ;

For a more comprehensive example, see the program list_formats.c in the examples/ directory of the libsndfile source code distribution.

Return value:
  0 on success and non-zero otherwise.
  The value of the format field will one of the major format identifiers such as SF_FORMAT_WAV SF_FORMAT_AIFF.
  The name field will contain a char* pointer to the name of the string; for instance "WAV (Microsoft)" or "AIFF (Apple/SGI)".
  The extention field will be a NULL pointer.

##
SFC_SET_ADD_PEAK_CHUNK

By default, WAV and AIFF files which contain floating point data (subtype SF_FORMAT_FLOAT or SF_FORMAT_DOUBLE) have a PEAK chunk. By using this command, the addition of a PEAK chunk can be turned on or off.

Note : This call must be made before any data is written to the file.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_ADD_PEAK_CHUNK
            data     : Not used (should be NULL)
            datasize : TRUE or FALSE.

Example:

            /* Turn on the PEAK chunk. */
            sf_command (sndfile, SFC_SET_ADD_PEAK_CHUNK, NULL, SF_TRUE) ;

            /* Turn off the PEAK chunk. */
            sf_command (sndfile, SFC_SET_ADD_PEAK_CHUNK, NULL, SF_FALSE) ;

Return value:
  Returns SF_TRUE if the peak chunk will be written after this call.
  Returns SF_FALSE if the peak chunk will not be written after this call.

##
SFC_UPDATE_HEADER_NOW

The header of an audio file is normally written by libsndfile when the file is closed using sf_close().

There are however situations where large files are being generated and it would be nice to have valid data in the header before the file is complete. Using this command will update the file header to reflect the amount of data written to the file so far. Other programs opening the file for read (before any more data is written) will then read a valid sound file header.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_UPDATE_HEADER_NOW
            data     : Not used (should be NULL)
            datasize : Not used.

Example:

            /* Update the header now. */
            sf_command (sndfile, SFC_UPDATE_HEADER_NOW, NULL, 0) ;

Return value:
  0

##
SFC_SET_UPDATE_HEADER_AUTO

Similar to SFC_UPDATE_HEADER_NOW but updates the header at the end of every call to the sf_write* functions.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_UPDATE_HEADER_NOW
            data     : Not used (should be NULL)
            datasize : SF_TRUE or SF_FALSE

Example:

            /* Turn on auto header update. */
            sf_command (sndfile, SFC_SET_UPDATE_HEADER_AUTO, NULL, SF_TRUE) ;

            /* Turn off auto header update. */
            sf_command (sndfile, SFC_SET_UPDATE_HEADER_AUTO, NULL, SF_FALSE) ;

Return value:
  TRUE if auto update header is now on; FALSE otherwise.

##
SFC_FILE_TRUNCATE

Truncate a file open for write or for read/write.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_FILE_TRUNCATE
            data     : A pointer to an sf_count_t.
            datasize : sizeof (sf_count_t)

Truncate the file to the number of frames specified by the sf_count_t pointed to by data. After this command, both the read and the write pointer will be at the new end of the file. This command will fail (returning non-zero) if the requested truncate position is beyond the end of the file.

Example:

            /* Truncate the file to a length of 20 frames. */
            sf_count_t  frames = 20 ;
            sf_command (sndfile, SFC_FILE_TRUNCATE, &frames, sizeof (frames)) ;

Return value:
  Zero on sucess, non-zero otherwise.

##
SFC_SET_RAW_START_OFFSET

Change the data start offset for files opened up as SF_FORMAT_RAW.

Parameters:

            sndfile  : A valid SNDFILE* pointer
            cmd      : SFC_SET_RAW_START_OFFSET
            data     : A pointer to an sf_count_t.
            datasize : sizeof (sf_count_t)

For a file opened as format SF_FORMAT_RAW, set the data offset to the value given by data.

Example:

            /* Reset the data offset to 5 bytes from the start of the file. */
            sf_count_t  offset = 5 ;
            sf_command (sndfile, SFC_SET_RAW_START_OFFSET, &offset, sizeof (offset)) ;

Return value:
  Zero on sucess, non-zero otherwise.

The libsndfile home page is here : http://www.mega-nerd.com/libsndfile/.
Version : 1.0.26